<template>
	<div :class="sidebar ? 'content-info col-md-11' : 'content-info col-md-9'" 
		 v-if="sessionSelected" 
		 :style="sessionstyles">

		<course-header></course-header>

		<course-description></course-description>

		<quiztimer v-if="session.type=='quiz'" @timerout="complete" :time="25"></quiztimer>

		<start-session-button></start-session-button>

		<course-modal></course-modal>

		<session-container ></session-container>

		<previous-session-container-button></previous-session-container-button>

		<next-session-container-button @complete="complete"></next-session-container-button>

	</div>
</template>

<script>

import { mapGetters, mapActions } 		from 'vuex'
import quiztimer 						from '../../CourseBuilder/quiztimer/index.vue'
import CourseHeader 					from './CourseHeader.vue'
import CourseDescription 				from './CourseDescription.vue'
import StartSessionButton 				from './StartSessionButton.vue'
import PreviousSessionContainerButton 	from './PreviousSessionContainerButton.vue'
import NextSessionContainerButton 		from './NextSessionContainerButton.vue'
import CourseModal 						from './CourseModal.vue'
import SessionContainer 				from './SessionContainer.vue'
import api from '../../../api'

export default {
	components: {
		CourseHeader, CourseDescription, StartSessionButton, CourseModal, SessionContainer,
		PreviousSessionContainerButton, NextSessionContainerButton, quiztimer,
	},
	computed: {
		dh(){
			return $('.wrapper').height() - 60
		},
		dw(){
			return $('.wrapper').width() - 125
		},
		sessionstyles() {
			//let anchito = this.sidebar ? '96%' : '91%'
			

			let width 	= this.sidebar ? `width:${this.dw}px;` : ''
			let height  = `min-height:${this.dh}px;`
			let grey 	= 'background-color: rgb(214, 215, 220);'
			let white 	= 'background-color: rgb(243, 244, 245);'
			return !this.hasStartedSession ? `${grey} ${width} ${height}` : `${white} ${width} ${height}`
		},
		...mapGetters([
			'session',
			'quizResult',
			'course',
			'courseInfo',
			'hasStartedSession',
			'sidebar',
		]),
		sessionSelected() {
			return this.session.name != ''
		},

	},
	methods: {
		...mapActions([
			'toggleComponentStatus',
			'finishSession',
			'evaluateQuiz',
			'displayModal',
		]),
		complete() {
			this.toggleComponentStatus()
			if (this.session.type == 'quiz' || this.session.type == 'eval') {
				this.evaluateQuiz().then(()=>{

					if (this.quizResult < 60) {
						this.displayModal('fail')
					} else {
						this.displayModal('success')
					}
					
				})
			}
			else {
				this.displayModal('finish')
			}
		}
	}
}
</script>

<style>
.fade-enter-active,
.fade-leave-active {
	-webkit-transition: all ease-out .2s;
	-moz-transition: all ease-out .2s;
	-o-transition: all ease-out .2s;
	-ms-transition: all ease-out .2s;
	transition: all ease-out .2s;
	transition: all ease-out .2s;
}

.fade-enter,
.fade-leave-to
/* .fade-leave-active below version 2.1.8 */

{
	opacity: 0;
}

.star-active {
	color: #43b86d;
}

.bg-inicio {
	position: absolute;
	background: rgba(60, 63, 64, 0.71);
	width: 102%;
	height: 100vh;
	margin-left: -15px;
	top: 0px;
	z-index: 5;
}
</style>